BEGIN
{
	push( @INC, ".." );
	push( @INC, "/tmp/webmin-1.520/net","/tmp/webmin-1.520/","/lib/perl5/5.10/Tie/");
	push( @INC, "/usr/libexec/webmin/net", "/usr/lib/perl5/5.8.8/Tie","../net" );
	push( @INC, "/usr/share/lib/Perl5/Tie","/usr/share/webmin/net")
}
use Switch;
use WebminCore;
require 'net-lib.pl';
init_config();
use Tie::IxHash;
use Encode qw( from_to is_utf8 );

# восстановить значения параметров настроек ком-порта
# данные беруться из файла intreface.config
sub RestoreCOMParametras()
{
	my ( $FileData, $interfaceSections, $ComPort ) = @_;
	my %ComInterfaces = GetCOMInterfaces();
	my %Data          = %$FileData;
	my %iFaceSect     = %$interfaceSections;
	my $iFaceComSect  = $ComPort;
	$iFaceComSect =~ s/(\d.*)//g;
	$iFaceComSect = "[" . $iFaceComSect . "]";
	foreach my $section ( keys %iFaceSect )
	{

		if ( $section ne $iFaceComSect )
		{
			next;
		}
		foreach my $par ( keys %{ $iFaceSect{$section} } )
		{
			if ( !defined( $Data{ "[" . $ComPort . "]" }{$par} ) )
			{
				$Data{ "[" . $ComPort . "]" }{$par} =
				  $iFaceSect{$section}{$par}{'DefValue'};
			}
		}
	}
	return %Data;
}

sub LoadKrugSettings()
{
	my @output = `cat /gsw/etc/krug.env`;
	my %data   = ();
	foreach $s (@output)
	{
		chomp($s);
		$_ = $s;
		if (/(\.*)\=(\.*)/)
		{
			my $tmp = "$'";
			$data{"$`"} = $tmp;
		}
	}
	return %data;
}

#сохранить данные в файл
# переаметры - хеш с пользовательскими данными
sub Save()
{
	my (%userdata)   = @_;
	my %KrugSettings = LoadKrugSettings();
	my $path         = $KrugSettings{'GSW_GUICFG'} . "IP2RS.data";
	my %filedata     = ParseKrugKntrIniFile($path);
	foreach my $section ( keys %userdata )
	{
		foreach my $param ( keys %{ $userdata{$section} } )
		{
			$filedata{$section}{$param} = $userdata{$section}{$param};
		}
	}
	my $OUTFILE;
	open( OUTFILE, ">" . $path ) or die print "sdfsdfsdfsdf";
	foreach my $section ( keys %filedata )
	{
		my $s = $section;
		from_to( $s, "utf8", "cp866" );
		print OUTFILE $s, "\n";

		#    print  $s,"\n";
		foreach my $param ( keys %{ $filedata{$section} } )
		{
			my $v = $filedata{$section}{$param};
			from_to( $v, "utf8", "cp866" );
			my $p = $param;
			from_to( $p, "utf8", "cp866" );
			print OUTFILE $p, "=", $v, "\n";
		}
	}
	close(OUTFILE);

	#перезапуск утилиты Ser2Net
	Ser2NetRestart(%filedata);
}

sub Ser2NetRestart()
{
	my %data = @_;
	my $ser2netConfig;
	my $additionalParams = "";
	my %KrugSettings     = LoadKrugSettings();
	my $path             = $KrugSettings{"GSW_SETTINGS"} . "ser2net.conf";
	open( ser2netConfig, ">$path" )
	  or die print
	  "Невозможно создать файл /gsw/etc/ser2net.conf";
	my $configstr;
	foreach my $section ( keys %data )
	{
		$_ = $section;
		if ( $_ =~ /(\w+)_(\w+)/ )
		{
			my $status = $data{$section}{'status'};
			if ( $status == 1 )
			{
				my $port     = $data{$section}{'port'};
				my $eth      = $data{$section}{'eth'};
				my $comname  = "[$2]";
				my $portname = "$2";
				if ( $eth =~ s/(\{)|(\})|(eth\d{1,2}\s)|(ALL)//g )
				{
					if ( length($eth) != 0 )
					{
						$configstr = $eth . ',' . $port . ':raw:';
					} else
					{
						$configstr = $port . ':raw:';
					}
					$configstr = $configstr . $data{$section}{'timeout'} . ':';
					$configstr = $configstr . "/dev/" . $portname . ':';
					$configstr = $configstr
					  . $data{$comname}{'COM_SPEED'} . ','
					  . $data{$comname}{'COM_PARITY'} . ',';
					if ( $data{$comname}{'COM_STOPBITS'} == 1 )
					{
						$configstr = $configstr
						  . $data{$comname}{'COM_STOPBITS'}
						  . 'STOPBIT,';
					} else
					{
						$configstr = $configstr
						  . $data{$comname}{'COM_STOPBITS'}
						  . 'STOPBITS,';
					}
					$configstr = $configstr
					  . $data{$comname}{'COM_DATA'}
					  . 'DATABITS'
					  . $additionalParams;
					print ser2netConfig $configstr, "\n";
				}
			}
		}
	}
	close(ser2netConfig);
	system( "sh", "/etc/init.d/s2net", "restart" );
}

# считать данные из файла конфигураций
sub ParseKrugKntrIniFile()
{
	my %KrugSettings = LoadKrugSettings();
	my $filename     = $KrugSettings{"GSW_GUICFG"} . "IP2RS.data";
	my %data         = GetIniFileData( $filename, "cp866" );
	$filename = $krugSettings{"GSW_GUICFG"}.'IP2RS/' . "interface.config";
	my %iFaceData = ParseInterfaceConfig($filename);
	return %data;
}

#чтение файлов конфигураций интерфейсов(interface.config)
sub ParseInterfaceConfig()
{
	my ($filename1) = @_;
	tie %Data, "Tie::IxHash";
	%Data = GetIniFileData( $filename1, "utf8" );
	tie %Return_Data, "Tie::IxHash";
	for my $section ( keys %Data )
	{
		for my $param ( keys %{ $Data{$section} } )
		{
			my $Sect = "[" . $Data{$section}{'Section'} . "]";
			my $Par  = $Data{$section}{'Param'};
			$Return_Data{$Sect}{$Par}{$param} = $Data{$section}{$param};
		}
	}
	return %Return_Data;
}

# парсер файлов конфигураций
sub GetIniFileData()
{
	my ( $filename, $encode ) = @_;
	my $INIFILE;
	my $section;
	tie %Data, "Tie::IxHash";
	if ( open( INIFILE, "<" . $filename ) != 0 )
	{
		while (<INIFILE>)
		{
			chomp;
			$_ =~ s/:.*//g;
			if (/\[.+?\]/)
			{
				$section = $_;
				from_to( $section, "cp866", "utf8" );
			}
			if (/(\.*)\=(\.*)/)
			{
				$s = "$`";
				$s =~ s/:.*//g;
				from_to( $s, "cp866", "utf8" );
				my $s1 = "$'";
				from_to( $s1, "cp866", "utf8" );
				$Data{$section}{$s} = $s1;
			}
		}
		close(INIFILE);
	}
	return %Data;
}

#получить список интерфейсов Ethernet
sub GetEthernetInterfaces()
{
	my @EthernetInterfaces = active_interfaces();
	my @IPInterfaces       = ();
	foreach $interface (@EthernetInterfaces)
	{
		if ( $interface->{'fullname'} =~ m/eth/ )
		{
			push(
				  @IPInterfaces,
				  [
					     $interface->{'fullname'} . " {"
					   . $interface->{'address'} . "}"
				  ]
			);
		}
	}
	push( @IPInterfaces, ["ALL"] );
	return @IPInterfaces;
}

#получить список com-интерфейсов
sub GetCOMInterfaces()
{
 opendir( DIR, "/dev/" );
 my @files = grep { /ttyS\d+$/ }readdir(DIR); # выбираем файлы ttys*  из каталога/dev/
 my %ComportParams = ();    #параметры com-порта
 
 foreach $file (@files)
 {
   $ComportParams{$file}{'name'}=$file;
 }
 closedir(DIR);
 return %ComportParams;
}
sub LoadConfig()
{
(my $filename)=@_;
my %Data=();
 $out=`iconv -f cp866 -t utf-8 $filename -o /tmp/ip2rs`;
my @out=`cat /tmp/ip2rs`;
my $i=0;
  my $section=();	
  my $comportnum=();

foreach $str (@out)
{ 
  $_=$str;
  if(/(\#{0,1})(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}){0,1},{0,1}(\d{1,5}):raw:(\d{1,5}):\/dev\/ttyS(\d{1,5}):(\d{1,6}),(\S+),(\d)STOPBITS{0,1},(\d)DATABITS{0,1},{0,1}(echo){0,1}/)
  {  	
  	my $status="$1";
  	my $ip="$2";
  	my $port="$3";
  	my $timout="$4";
       $comportnum="$5";
  	my $speed="$6";
  	my $parity="$7";
  	my $stopbits="$8";
  	my $databits="$9";
  	my $echo="$10";
  	my $comment="$11";
  #	print "ip=$ip<br>port=$port<br>timeout=$timout<br>com=$comportnum<br>speed=$speed<br>par=$parity<br>stop=$stopbits<br>data=$databits<br>echo=$echo<br>comment=$comment";
  	if(length($ip)==0)
  	{
  		$ip="ALL";
  	}
  	if(length($status)==0)
  	{
  		$status=1;
  	}
  	else
  	{
  		$status=0;
  	}
  	 $section="[ttyS$comportnum]";
  	$Data{$section}{"COM_STOPBITS"}=$stopbits;
  	$Data{$section}{"COM_SPEED"}=$speed;
  	$Data{$section}{"COM_PARITY"}=$parity;
  	$Data{$section}{"COM_DATA"}=$databits;
  	$comment=~s/\#//g;
  	$Data{$section}{"COM_NAME"}=$comment;
  	if(length($echo)>0)
  	{
  	  $Data{$section}{"COM_ECHO"}="Да";
  	}
  	else
  	{
  	  $Data{$section}{"COM_ECHO"}="Нет";
  	}
  	$section="[LINK_ttyS$comportnum]";
  	$Data{$section}{"timeout"}=$timout;
  	$Data{$section}{"port"}=$port;
  	$Data{$section}{"eth"}=$ip;
  	$Data{$section}{"status"}=$status;  	  	
  }	
  else
  {
  	  $section=~s/LINK_//g;
  	if($i>=0)
  	{
  	$_=$out[$i];
  	if(/^\#(.*)$/)
  	{
  	  $Data{$section}{"COM_NAME"}="$1";
  	}
  	}
  	else
  	{
  	$Data{$section}{"COM_NAME"}=undef;
  	}
  	
  }
  $i++;
}
return %Data;
}
# вывод сообщение о результате сохранения
#sub SaveComplete()
#{
#my ($messagetext) = @_;
#print "<p align='center'>";
#print '<FONT size=20 Color="green">';
#print "<b>",$messagetext,"</b>";
#print "  </FONT>";
#print "</p>";
#}
